
# line 89 "calculator.y"
#include "config.h"
#ifndef DIGITAL
 #include<stdio.h>
 #include<string.h>
 #include<stdlib.h> 
 #include<math.h>
#endif
#include "calculator.h"
#include "xmtnimage.h"

void addfunc(char *name, double(*func)(double));
void addfunc2(char *name, double(*func)(double,double));
void addfunc3(char *name, double(*func)(double,double,double));
void addfunc4(char *name, double(*func)(double,double,double,double));
void addfuncchar(char *name, double(*func)(char *));
void addfuncchar2(char *name, void(*func)(char*, char*));
double drand(double a); 
void skip_to_end(void);
void skip_to_end_of_line(void);
double dmax(double a, double b);
double dmin(double a, double b);
struct symtab* symlook(char *s);
void print_number(FILE *stream, double number);
void print_string(FILE *stream, char *string);

int input(void);
int yyinput(void);
char *string(struct symtab *sym);
#ifndef MIPS
extern int yylex(void);
#endif
void yyerror(char *s);
void yyrestart ( FILE *input_file );

extern Globals     g;
extern Image      *z;
extern int         ci;
extern char yy_hold_char, yy_n_chars;
extern int ii,rr,gg,bb; 
extern char *text;
extern char *yytext;
extern int column;      /* where the error is */

extern char *yy_current_buffer;
extern int yy_init;     /* whether we need to initialize */
extern int yy_start;    /* start state number */
extern int status;
extern char *yy_c_buf_p;
int if_true=0, print_count, datatype;
int rr,gg,bb,v,x,y,xstart,ystart,xend,yend,frame,bpp,ino,len;
int lineno,k,comp,invert;
char *position=0;
int fff;
FILE *fp;
static char filename[FILENAMELENGTH];
static char tempstring[128];

# line 147 "calculator.y"
typedef union  {  double dval;
          struct symtab *symp;
       } YYSTYPE;
#ifdef __cplusplus
#  include <stdio.h>
/*
#  include <yacc.h>
*/
#endif	/* __cplusplus */ 
# define NAME 257
# define NUMBER 258
# define YYSTRING 259
# define IDENTIFIER 260
# define EQ 261
# define LE 262
# define GE 263
# define PLUS_EQUALS 264
# define MINUS_EQUALS 265
# define TIMES_EQUALS 266
# define DIVIDE_EQUALS 267
# define LOGICAL_AND 268
# define LOGICAL_OR 269
# define INCREMENT 270
# define DECREMENT 271
# define IMAGE 272
# define RED 273
# define GREEN 274
# define BLUE 275
# define YYREAL 276
# define YYIMAG 277
# define YYWAVE 278
# define AREA 279
# define DENSITY 280
# define OPEN 281
# define READ 282
# define WRITE 283
# define PRINT 284
# define CLOSE 285
# define IF 286
# define THEN 287
# define ELSE 288
# define CASE 289
# define DEFAULT 290
# define SWITCH 291
# define WHILE 292
# define DO 293
# define FOR 294
# define GOTO 295
# define CONTINUE 296
# define BREAK 297
# define RETURN 298
# define UMINUS 299
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif

/* __YYSCLASS defines the scoping/storage class for global objects
 * that are NOT renamed by the -p option.  By default these names
 * are going to be 'static' so that multi-definition errors
 * will not occur with multiple parsers.
 * If you want (unsupported) access to internal names you need
 * to define this to be null so it implies 'extern' scope.
 * This should not be used in conjunction with -p.
 */
#ifndef __YYSCLASS
# define __YYSCLASS static
#endif
YYSTYPE yylval;
__YYSCLASS YYSTYPE yyval;
typedef int yytabelem;
# define YYERRCODE 256

# line 454 "calculator.y"



void initialize_evaluator(void)
{   
   /* 1-parameter functions - new functions can be added here */
   addfunc("abs",  fabs); 
   addfunc("acos", acos); 
   addfunc("asin", asin); 
   addfunc("atan", atan); 
   addfunc("cos",  cos); 
   addfunc("cosh", cosh); 
   addfunc("exp",  exp);
   addfunc("log",  log); 
   addfunc("log10",log10); 
   addfunc("rand", drand); 
   addfunc("sin",  sin); 
   addfunc("sinh", sinh); 
   addfunc("sqrt", sqrt);
   addfunc("tan",  tan); 
   addfunc("tanh", tanh); 
   addfunc("erf",  erf); 
   addfunc("spotsize", spot_size); 
   addfunc("spotsignal", spot_signal); 
   addfunc("spotx", spot_x); 
   addfunc("spoty", spot_y); 
   addfunc("pixels", pixels); 

#ifdef HAVE_ASINH
   addfunc("asinh",asinh); 
#endif
#ifdef HAVE_ACOSH
   addfunc("acosh",acosh); 
#endif
#ifdef HAVE_ATANH
   addfunc("atanh",atanh); 
#endif
#ifdef HAVE_CBRT
   addfunc("cbrt", cbrt); 
#endif

   /* 2-parameter functions - new functions can be added here */
   addfunc2("pow", pow); 
   addfunc2("min", dmin); 
   addfunc2("max", dmax); 

   /* 3-parameter functions - new functions can be added here */
   addfunc3("between", fbetween); 
   addfunc3("cdensity", cdensity); 

   /* 4-parameter functions - new functions can be added here */
   addfunc4("rdensity", rdensity); 

   /* functions with 1 string - new functions can be added here */
   addfuncchar("input", macro_double_input);

   addfuncchar2("getstring", macro_string_input);

   /* Functions that take a string as argument */
   /* To use this, change the YYSTRING entry from:
        |   YYSTRING  
                 {   len = strlen($1->name)-2;
                     strncpy(tempstring,$1->name+1,len);
                     tempstring[len]=0;
                     $$ = double_image_number(tempstring);
                 }
      to:
        |   NAME '(' YYSTRING ')' 
                 {
                    if($1-> char)
                    {   len = strlen($3->name)-2;
                        strncpy(tempstring,$3->name+1,len);
                        tempstring[len]=0;
                        $$ = ($1->funcptrchar)(tempstring);
                    }else
                    {   sprintf(tempstring, "Argument to %s is not a string\n", $1->name);
                        yyerror(tempstring);
                        $$ = 0.0;
                    }                    
     Can't have both because it causes a shift/reduce conflict.
   */
   /* addfuncchar("ino", double_image_number); */

   lineno = 0;
   yy_n_chars = 0;
}

void yyerror(char *s)
{  
   formula_error(s, text); 
   yyrestart(NULL);
}

void add_variable(char *name, double value)
{
   struct symtab *sp = symlook(name);
   sp->funcptr1 = NULL;
   sp->funcptr2 = NULL;
   sp->funcptr3 = NULL;
   sp->funcptr4 = NULL;
   sp->funcptrchar = NULL;
   sp->funcptrchar2 = NULL;
   sp->value = value;
   sp->datatype = FLOAT;
}

/* Include a value so a number can be assoc. with string, eg fp for filename */
void add_string_variable(char *name, char *string, double value)
{
   if(string==NULL) return;
   struct symtab *sp = symlook(name);
   sp->funcptr1 = NULL;
   sp->funcptr2 = NULL;
   sp->funcptr3 = NULL;
   sp->funcptr4 = NULL;
   sp->funcptrchar = NULL;
   sp->funcptrchar2 = NULL;
   sp->value = value;
   if(sp->string!=NULL) free(sp->string);
   sp->string = strdup(string);
   sp->datatype = STRING;
}

void addfunc(char *name, double(*func)(double))
{
   struct symtab *sp = symlook(name);
   sp->funcptr1 = func;
   sp->funcptr2 = NULL;
   sp->funcptr3 = NULL;
   sp->funcptr4 = NULL;
   sp->funcptrchar = NULL;
   sp->funcptrchar2 = NULL;
}

void addfunc2(char *name, double(*func)(double, double))
{
   struct symtab *sp = symlook(name);
   sp->funcptr1 = NULL;
   sp->funcptr2 = func;
   sp->funcptr3 = NULL;
   sp->funcptr4 = NULL;
   sp->funcptrchar = NULL;
   sp->funcptrchar2 = NULL;
}

void addfunc3(char *name, double(*func)(double, double, double))
{
   struct symtab *sp = symlook(name);
   sp->funcptr1 = NULL;
   sp->funcptr2 = NULL;
   sp->funcptr3 = func;
   sp->funcptr4 = NULL;
   sp->funcptrchar = NULL;
   sp->funcptrchar2 = NULL;
}

void addfunc4(char *name, double(*func)(double, double, double, double))
{
   struct symtab *sp = symlook(name);
   sp->funcptr1 = NULL;
   sp->funcptr2 = NULL;
   sp->funcptr3 = NULL;
   sp->funcptr4 = func;
   sp->funcptrchar = NULL;
   sp->funcptrchar2 = NULL;
}

void addfuncchar(char *name, double(*func)(char *))
{
   struct symtab *sp = symlook(name);
   sp->funcptr1 = NULL;
   sp->funcptr2 = NULL;
   sp->funcptr3 = NULL;
   sp->funcptr4 = NULL;
   sp->funcptrchar = func;
   sp->funcptrchar2 = NULL;
}

void addfuncchar2(char *name, void(*func)(char*, char*))
{
   struct symtab *sp = symlook(name);
   sp->funcptr1 = NULL;
   sp->funcptr2 = NULL;
   sp->funcptr3 = NULL;
   sp->funcptr4 = NULL;
   sp->funcptrchar = NULL;
   sp->funcptrchar2 = func;
}



double read_variable(char *name, char *answer, int &datatype)
{
   struct symtab *sp = symlook(name);
   if(sp->datatype==STRING && answer != NULL)
   {
       if(sp->string) strcpy(answer, sp->string); else answer[0]=0;
   }
   datatype = sp->datatype;
   return sp->value;
}


struct symtab* symlook(char *s)
{
   struct symtab *sp;
   for(sp=symtab; sp< &symtab[NSYMS]; sp++)
   {  
       if(sp->name && !strcmp(sp->name, s)) return sp;  /* is it already here */
       if(!sp->name)                                    /* is it free         */
       {   sp->name = strdup(s); 
           sp->string = NULL;
           sp->datatype = NONE;
           return sp; 
       }
   }
   /* Make sure they don't know what to do */
   yyerror("Too many symbols, ask a wizard to enlarge me");
   return NULL;
}

void skip_to_end(void)
{
   while(strchr("\n ",yy_hold_char)!=NULL) yyinput(); 
   int got_left_brace = yy_hold_char=='{';
   if(got_left_brace)
   {   while(yy_hold_char != '}')
       {    yyinput();
            if(yy_hold_char==0) break;
       }
   }else
   {   while(strchr(";}\n",yy_hold_char)==NULL) yyinput(); 
   }
   yyinput();
   while(yy_hold_char=='\n') yyinput(); 
}

void skip_to_end_of_line(void)
{
   while(yy_hold_char != '\n' && yy_hold_char) yyinput(); 
   yyinput();
}

double dmax(double a, double b){ if(a>b) return a; return b; }
double dmin(double a, double b){ if(a<b) return a; return b; }
double drand(double a){ a=a; return rand()/(double)RAND_MAX; }

char *string(struct symtab *sym)
{
   static char sss[FILENAMELENGTH];
   len = strlen(sym->name)-2;
   strncpy(sss, sym->name+1, len);
   sss[len]=0;
   return sss;
}

void print_number(FILE *stream, double number) 
{
   fprintf(stream, "%g",number); 
   fflush(stream);
}

void print_string(FILE *stream, char *string)
{
   int j,k;
   char *s;
   int len = strlen(string);
   j=0;
   s = (char*) malloc(16384);
   for(k=0; k<len; k++) 
   {   if(k<len-1 && string[k]=='\\') switch(string[++k])
       {   case '0': s[j++] = '\0'; break;
           case 'a': s[j++] = '\a'; break;
           case 'b': s[j++] = '\b'; break;
           case 't': s[j++] = '\t'; break;
           case 'n': s[j++] = '\n'; break;
           case 'v': s[j++] = '\v'; break;
           case 'f': s[j++] = '\f'; break;
           case 'r': s[j++] = '\r'; break;
           case '\\': s[j++] = '\\'; break;
       }else s[j++] = string[k];
   }
   s[j] = 0;
   fprintf(stream, "%s",s);
   fflush(stream);
   free(s);
}
__YYSCLASS yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 85
# define YYLAST 2042
__YYSCLASS yytabelem yyact[]={

    12,   121,    37,   103,    63,   245,   244,   184,    54,    52,
   185,    53,    25,    55,   243,   242,   241,   224,     2,    27,
    38,   223,   222,    25,    24,    16,    56,   221,    57,   220,
    27,   219,    12,   218,   217,    24,   183,    68,   182,   181,
   180,   179,   178,   177,   176,    87,    86,    85,    84,    83,
    82,    81,    80,   214,   203,    25,   168,   166,   165,    38,
    65,   164,    27,   163,    12,   162,   161,    24,   142,   141,
   123,    54,    52,   104,    53,    72,    55,    71,    54,    52,
    54,    53,   150,    55,   171,    55,   120,    25,   122,    56,
    64,    57,   201,   146,    27,   202,   147,    39,   145,    24,
    15,   151,    48,    69,    67,    26,    66,    50,   134,    49,
    51,     1,    97,     5,    96,   140,    26,    40,   139,   138,
    63,    70,   137,   186,    54,    52,   148,    53,   100,    55,
     8,     7,   136,   135,     4,     3,     0,     0,    48,     0,
    88,   152,    56,     0,    57,     0,     0,    89,    26,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    41,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   172,
     0,     0,     0,     0,     0,     0,    65,     0,     0,     0,
    26,     0,     0,     0,    25,     0,     0,     0,     0,     0,
     0,    27,     0,   190,     0,     0,    24,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    64,     0,    25,     0,
   204,     0,     0,     0,     0,    27,   174,     0,     0,     0,
    24,     0,     0,     0,     0,     0,     0,    60,    58,    59,
     0,     0,    25,     0,    61,    62,    75,    28,   216,    27,
     0,     0,     0,     0,    24,     0,     0,     6,    28,     0,
    37,    30,    31,    32,    33,    34,    35,    36,     0,    29,
     0,     0,    30,    31,    32,    33,    34,    35,    36,     0,
    29,     0,     0,    10,     9,     0,    13,    26,    14,     6,
    28,     0,    17,    18,    19,    20,    21,    22,    23,     0,
    60,    58,    59,     0,    30,    31,    32,    33,    34,    35,
    36,    26,    29,     0,     0,    10,     9,     0,    13,     0,
    14,     6,    28,     0,    17,    18,    19,    20,    21,    22,
    23,     0,     0,     0,     0,    26,    30,    31,    32,    33,
    34,    35,    36,    11,    29,     0,     0,    10,     9,     0,
    13,     0,    14,    60,    58,    59,    17,    18,    19,    20,
    21,    22,    23,     0,     0,     0,     0,    74,    76,    77,
    78,    79,    42,    43,    44,    45,     0,     0,    46,    47,
     0,     0,     0,    25,     0,    90,    92,    93,    94,    95,
    27,     0,    98,   101,     0,    24,   105,   106,   107,   108,
   109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
   119,     0,     0,     0,     0,     0,     0,     0,    75,    28,
   188,     0,     0,     0,   126,   127,   128,   129,   130,   131,
   132,   133,     0,    30,    31,    32,    33,    34,    35,    36,
    25,    29,    75,    28,     0,     0,     0,    27,     0,     0,
     0,     0,    24,     0,     0,     0,     0,    30,    31,    32,
    33,    34,    35,    36,     0,    29,    75,    28,   170,     0,
     0,     0,     0,     0,     0,     0,    26,     0,     0,     0,
     0,    30,    31,    32,    33,    34,    35,    36,   167,    29,
    25,   169,     0,     0,     0,   173,   175,    27,     0,    25,
     0,     0,    24,     0,     0,     0,    27,     0,     0,     0,
     0,    24,     0,     0,     0,   187,     0,     0,     0,     0,
   192,   193,   194,   195,   196,   197,   198,   199,    25,   200,
     0,     0,     0,    26,     0,    27,     0,     0,     0,     0,
    24,     0,     0,     0,     0,     0,   215,     0,     0,     0,
     0,     0,     0,     0,    73,     0,     0,     0,     0,     0,
     0,   225,   226,   227,   228,   229,   230,   231,   232,     0,
     0,     0,     0,    63,     0,     0,   143,    54,    52,   144,
    53,     0,    55,    26,     0,   246,   247,   248,   249,   250,
     0,     0,    26,     0,     0,    56,     0,    57,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    75,    28,   102,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    26,    30,    31,    32,    33,    34,    35,    36,    65,
    29,     0,     0,    63,     0,     0,     0,    54,    52,     0,
    53,     0,    55,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    56,     0,    57,     0,    64,
     0,     0,     0,     0,    75,    28,    99,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    30,
    31,    32,    33,    34,    35,    36,     0,    29,   255,    65,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    63,     0,     0,     0,    54,    52,     0,
    53,     0,    55,     0,    75,    28,    91,     0,     0,    64,
     0,     0,     0,    75,    28,    56,     0,    57,     0,    30,
    31,    32,    33,    34,    35,    36,     0,    29,    30,    31,
    32,    33,    34,    35,    36,     0,    29,     0,     0,     0,
     0,     0,    75,    28,     0,     0,    63,     0,   254,    65,
    54,    52,     0,    53,     0,    55,     0,    30,    31,    32,
    33,    34,    35,    36,     0,    29,     0,     0,    56,     0,
    57,     0,     0,    63,     0,     0,     0,    54,    52,    64,
    53,     0,    55,     0,     0,     0,    60,    58,    59,     0,
     0,     0,     0,    61,    62,    56,     0,    57,     0,     0,
    63,   253,    65,     0,    54,    52,     0,    53,     0,    55,
     0,    63,     0,     0,     0,    54,    52,     0,    53,     0,
    55,     0,    56,     0,    57,     0,     0,     0,   252,    65,
     0,     0,    64,    56,     0,    57,    63,     0,     0,     0,
    54,    52,     0,    53,     0,    55,    60,    58,    59,     0,
     0,     0,     0,    61,    62,   251,    65,     0,    56,    64,
    57,     0,     0,     0,     0,    63,   240,    65,     0,    54,
    52,     0,    53,     0,    55,     0,    63,     0,     0,     0,
    54,    52,     0,    53,     0,    55,    64,    56,     0,    57,
     0,   239,    65,     0,     0,     0,     0,    64,    56,     0,
    57,     0,     0,    63,     0,     0,     0,    54,    52,     0,
    53,     0,    55,     0,     0,     0,    60,    58,    59,     0,
   238,    65,    64,    61,    62,    56,     0,    57,     0,     0,
    63,   237,    65,     0,    54,    52,     0,    53,     0,    55,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    64,    56,     0,    57,     0,     0,     0,   236,    65,
     0,     0,    64,     0,     0,     0,     0,     0,     0,    60,
    58,    59,     0,     0,     0,     0,    61,    62,     0,     0,
     0,     0,     0,    63,     0,   235,    65,    54,    52,    64,
    53,     0,    55,     0,     0,     0,    60,    58,    59,     0,
     0,     0,     0,    61,    62,    56,     0,    57,     0,     0,
     0,     0,     0,     0,     0,     0,    64,     0,     0,     0,
     0,     0,     0,    60,    58,    59,     0,     0,     0,     0,
    61,    62,     0,     0,    60,    58,    59,     0,   234,    65,
     0,    61,    62,     0,     0,     0,     0,     0,     0,    63,
     0,     0,     0,    54,    52,     0,    53,     0,    55,    60,
    58,    59,     0,     0,     0,     0,    61,    62,     0,    64,
     0,    56,     0,    57,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    60,    58,
    59,     0,     0,     0,     0,    61,    62,     0,     0,    60,
    58,    59,     0,     0,   233,    65,    61,    62,    63,     0,
     0,   213,    54,    52,     0,    53,     0,    55,     0,     0,
     0,     0,     0,     0,     0,     0,    60,    58,    59,     0,
    56,     0,    57,    61,    62,    64,     0,     0,     0,     0,
     0,    63,     0,     0,     0,    54,    52,     0,    53,     0,
    55,     0,     0,    60,    58,    59,     0,     0,     0,     0,
    61,    62,    63,    56,    65,    57,    54,    52,     0,    53,
     0,    55,     0,     0,     0,     0,    63,     0,     0,     0,
    54,    52,     0,    53,    56,    55,    57,     0,     0,     0,
     0,     0,     0,     0,    64,     0,   212,    65,    56,     0,
    57,     0,     0,     0,     0,     0,    60,    58,    59,     0,
     0,     0,     0,    61,    62,    63,     0,   211,    65,    54,
    52,     0,    53,     0,    55,     0,     0,    64,     0,    63,
     0,   210,    65,    54,    52,     0,    53,    56,    55,    57,
     0,     0,     0,     0,     0,     0,     0,     0,    64,     0,
     0,    56,     0,    57,    63,     0,     0,     0,    54,    52,
     0,    53,    64,    55,     0,     0,     0,     0,     0,     0,
   209,    65,    60,    58,    59,     0,    56,     0,    57,    61,
    62,     0,     0,     0,   208,    65,     0,     0,     0,    63,
     0,     0,     0,    54,    52,     0,    53,     0,    55,     0,
     0,    64,     0,     0,     0,     0,     0,     0,     0,   207,
    65,    56,    63,    57,     0,    64,    54,    52,     0,    53,
     0,    55,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    60,    58,    59,    56,     0,    57,     0,    61,    62,
    64,     0,     0,     0,   206,    65,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    60,    58,    59,   205,    65,     0,
     0,    61,    62,     0,     0,    64,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    60,    58,    59,     0,     0,
     0,     0,    61,    62,     0,     0,     0,     0,    64,    60,
    58,    59,     0,     0,     0,    63,    61,    62,   191,    54,
    52,     0,    53,     0,    55,     0,     0,     0,     0,    63,
     0,     0,   189,    54,    52,     0,    53,    56,    55,    57,
     0,     0,     0,     0,     0,     0,     0,     0,    60,    58,
    59,    56,     0,    57,     0,    61,    62,     0,     0,     0,
     0,     0,    60,    58,    59,     0,     0,     0,     0,    61,
    62,    65,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    65,     0,    60,    58,    59,
     0,     0,     0,     0,    61,    62,     0,     0,     0,     0,
     0,    64,     0,    63,     0,     0,     0,    54,    52,     0,
    53,     0,    55,     0,     0,    64,     0,     0,     0,     0,
     0,     0,    60,    58,    59,    56,     0,    57,     0,    61,
    62,     0,    63,     0,     0,     0,    54,    52,     0,    53,
     0,    55,     0,     0,     0,    60,    58,    59,     0,     0,
     0,     0,    61,    62,    56,     0,    57,    63,   160,    65,
     0,    54,    52,     0,    53,     0,    55,     0,     0,    63,
     0,     0,     0,    54,    52,     0,    53,     0,    55,    56,
     0,    57,     0,     0,     0,     0,     0,   159,    65,    64,
     0,    56,    63,    57,     0,     0,    54,    52,     0,    53,
     0,    55,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   158,    65,    56,     0,    57,     0,    64,     0,
     0,     0,     0,     0,   157,    65,     0,    63,     0,     0,
     0,    54,    52,     0,    53,     0,    55,     0,    60,    58,
    59,     0,     0,    64,     0,    61,    62,   156,    65,    56,
     0,    57,    60,    58,    59,    64,     0,     0,     0,    61,
    62,     0,    63,     0,     0,     0,    54,    52,     0,    53,
     0,    55,     0,     0,     0,     0,     0,     0,    64,     0,
     0,     0,   155,    65,    56,    63,    57,     0,     0,    54,
    52,     0,    53,     0,    55,     0,     0,    63,     0,     0,
   149,    54,    52,     0,    53,     0,    55,    56,     0,    57,
     0,     0,     0,    64,     0,     0,     0,   154,    65,    56,
     0,    57,     0,     0,     0,     0,    60,    58,    59,     0,
     0,     0,     0,    61,    62,     0,     0,     0,     0,     0,
   153,    65,    63,     0,     0,   125,    54,    52,    64,    53,
     0,    55,     0,    65,     0,    60,    58,    59,     0,     0,
     0,     0,    61,    62,    56,     0,    57,     0,     0,     0,
     0,    64,     0,     0,     0,     0,     0,     0,     0,     0,
    60,    58,    59,    64,     0,     0,     0,    61,    62,     0,
     0,     0,    60,    58,    59,     0,     0,    63,    65,    61,
    62,    54,    52,     0,    53,     0,    55,     0,     0,     0,
     0,     0,     0,     0,     0,    60,    58,    59,   124,    56,
    63,    57,    61,    62,    54,    52,     0,    53,    64,    55,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    56,     0,    57,     0,     0,     0,     0,     0,
    60,    58,    59,    65,     0,     0,     0,    61,    62,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    65,     0,     0,     0,
     0,     0,     0,    64,     0,    60,    58,    59,     0,     0,
     0,     0,    61,    62,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    64,     0,    60,    58,
    59,     0,     0,     0,     0,    61,    62,     0,     0,     0,
    60,    58,    59,     0,     0,     0,     0,    61,    62,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    60,    58,    59,     0,     0,
     0,     0,    61,    62,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    60,    58,    59,     0,     0,     0,     0,    61,    62,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    60,    58,    59,     0,     0,     0,     0,
    61,    62 };
__YYSCLASS yytabelem yypact[]={

   -10,    54, -3000,    53, -3000,   -10,    98, -3000, -3000,    69,
    67,  1772, -3000,    66, -3000, -3000, -3000,    64,    54,    63,
  -258,    18,    16,   485,   456,   456,   456,   456, -3000,   -39,
   -40,   -41,   -42,   -43,   -44,   -45,   -46, -3000, -3000,  -258,
    22,   447,   456,   456,   456,   456, -3000, -3000,   397,   340,
  -256,    14,   456,   456,   456,   456,   456,   456,   456,   456,
   456,   456,   456,   456,   456,   456,   456,    54,  -291,    54,
    11, -3000, -3000, -3000,  1749,    62, -3000, -3000, -3000,  1694,
   456,   456,   456,   456,   456,   456,   456,   456, -3000,    54,
  1772, -3000,  1772,  1772,  1772,  1772,    10,     9,   525,    57,
    52,  1772, -3000, -3000, -3000,    38,    38, -3000, -3000,    36,
    36,    36,    36,    36,    82,    82,    29,    29,    29,  1649,
    41,    61,    54, -3000, -3000, -3000,  1637,  1614,  1579,  1544,
  1521,  1509,  1484,  1455, -3000,     7,     6,     4,     2,    -1,
    -2, -3000, -3000, -3000,   456, -3000,    -3,   199,    40, -3000,
    54,   456,   175,   -47,   -48,   -49,   -50,   -51,   -52,   -53,
   -55, -3000, -3000, -3000, -3000, -3000, -3000,   -34, -3000,  1772,
 -3000,   151, -3000,  1381,    54,  1367,   456,   456,   456,   456,
   456,   456,   456,   456, -3000,   456,    51,  1772, -3000,    -5,
 -3000,    54,  1274,  1251,  1216,  1191,  1177,  1138,  1124,  1103,
  1070,    -6,   -21, -3000, -3000,   -57,   -58,   -60,   -62,   -64,
   -69,   -70,   -74, -3000, -3000,  1772, -3000,   456,   456,   456,
   456,   456,   456,   456,   456,  1011,   945,   892,   865,   838,
   827,   798,   773,   -75,   -76,   -77,   -85,   -86, -3000, -3000,
 -3000,   456,   456,   456,   456,   456,   762,   735,   708,   655,
   585, -3000, -3000, -3000, -3000, -3000 };
__YYSCLASS yytabelem yypgo[]={

     0,   333,   111,    18,   135,   134,   133,   132,   131,   130,
   128,   126,   123,   122,   119,   118,   115,   114,   112,   110,
   100 };
__YYSCLASS yytabelem yyr1[]={

     0,     2,     2,     2,     2,     2,     6,     3,     7,     3,
     3,     3,     3,    11,     3,    13,     3,    14,     3,    15,
     3,    16,     3,    17,     3,    18,     3,    19,     3,     3,
     3,     3,     5,     8,     8,     8,     8,     9,     9,     9,
     9,     9,     4,     4,    10,    10,    10,    10,    12,    12,
    12,    12,    20,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1 };
__YYSCLASS yytabelem yyr2[]={

     0,     2,     2,     2,     4,     8,     1,    10,     1,    10,
     2,     2,    10,     1,    16,     1,    10,     1,    10,     1,
    10,     1,    10,     1,     8,     1,     8,     1,     6,     2,
     9,     3,     3,    10,    14,    12,    14,     6,     4,     4,
     4,     6,     2,     6,     7,     7,     3,     3,     7,     7,
     3,     3,     2,     7,     7,     7,     7,     5,     5,     5,
     7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
     7,     2,     3,     9,    13,    17,     9,    27,    27,    27,
    27,    27,    21,    21,    21 };
__YYSCLASS yytabelem yychk[]={

 -3000,    -2,    -3,    -4,    -5,   123,   257,    -8,    -9,   284,
   283,    -1,    10,   286,   288,   -20,    35,   292,   293,   294,
   295,   296,   297,   298,    45,    33,   126,    40,   258,   280,
   272,   273,   274,   275,   276,   277,   278,   260,    -3,    44,
    -2,    61,   264,   265,   266,   267,   270,   271,    40,    40,
    40,   -19,    43,    45,    42,    47,    60,    62,   262,   263,
   261,   268,   269,    38,   124,    94,    40,    40,    -3,    40,
   -20,    59,    59,    59,    -1,   257,    -1,    -1,    -1,    -1,
    91,    91,    91,    91,    91,    91,    91,    91,   -20,   125,
    -1,   259,    -1,    -1,    -1,    -1,   -17,   -18,    -1,   259,
   -10,    -1,   259,   259,    59,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -3,   292,    -3,    59,    59,    41,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -3,    -6,    -7,   -13,   -14,   -15,
   -16,    59,    59,    41,    44,    41,    41,    44,   -11,    41,
    41,    40,    -3,    93,    93,    93,    93,    93,    93,    93,
    93,    59,    59,    59,    59,    59,    59,    -1,    59,    -1,
   259,    44,    -3,    -1,    41,    -1,    91,    91,    91,    91,
    91,    91,    91,    91,    41,    44,   -12,    -1,   259,    41,
    -3,    41,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    41,    44,    59,    -3,    93,    93,    93,    93,    93,
    93,    93,    93,    41,    59,    -1,   259,    91,    91,    91,
    91,    91,    91,    91,    91,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    93,    93,    93,    93,    93,    93,    93,
    93,    91,    91,    91,    91,    91,    -1,    -1,    -1,    -1,
    -1,    93,    93,    93,    93,    93 };
__YYSCLASS yytabelem yydef[]={

     0,    -2,     1,     2,     3,     0,    72,    10,    11,     0,
     0,    27,    29,     0,    31,    42,    32,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    71,     0,
     0,     0,     0,     0,     0,     0,     0,    52,     4,     0,
     0,     0,     0,     0,     0,     0,    23,    25,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    38,    39,    40,     0,    72,    57,    58,    59,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    43,     0,
     6,     8,    15,    17,    19,    21,     0,     0,     0,     0,
     0,    46,    47,    13,    28,    53,    54,    55,    56,    61,
    62,    63,    64,    65,    66,    67,    68,    69,    70,     0,
     0,     0,     0,    37,    41,    60,     0,     0,     0,     0,
     0,     0,     0,     0,     5,     0,     0,     0,     0,     0,
     0,    24,    26,    73,     0,    76,     0,     0,     0,    30,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     7,     9,    16,    18,    20,    22,     0,    12,    44,
    45,     0,    33,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    74,     0,     0,    50,    51,     0,
    35,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    34,    36,     0,     0,     0,     0,     0,
     0,     0,     0,    75,    14,    48,    49,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    82,    83,
    84,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    77,    78,    79,    80,    81 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

__YYSCLASS yytoktype yytoks[] =
{
	"NAME",	257,
	"NUMBER",	258,
	"YYSTRING",	259,
	"IDENTIFIER",	260,
	"EQ",	261,
	"LE",	262,
	"GE",	263,
	"PLUS_EQUALS",	264,
	"MINUS_EQUALS",	265,
	"TIMES_EQUALS",	266,
	"DIVIDE_EQUALS",	267,
	"LOGICAL_AND",	268,
	"LOGICAL_OR",	269,
	"INCREMENT",	270,
	"DECREMENT",	271,
	"IMAGE",	272,
	"RED",	273,
	"GREEN",	274,
	"BLUE",	275,
	"YYREAL",	276,
	"YYIMAG",	277,
	"YYWAVE",	278,
	"AREA",	279,
	"DENSITY",	280,
	"OPEN",	281,
	"READ",	282,
	"WRITE",	283,
	"PRINT",	284,
	"CLOSE",	285,
	"IF",	286,
	"THEN",	287,
	"ELSE",	288,
	"CASE",	289,
	"DEFAULT",	290,
	"SWITCH",	291,
	"WHILE",	292,
	"DO",	293,
	"FOR",	294,
	"GOTO",	295,
	"CONTINUE",	296,
	"BREAK",	297,
	"RETURN",	298,
	"&",	38,
	"|",	124,
	"^",	94,
	"<",	60,
	">",	62,
	"-",	45,
	"+",	43,
	"*",	42,
	"/",	47,
	"UMINUS",	299,
	"!",	33,
	"~",	126,
	"-unknown-",	-1	/* ends search */
};

__YYSCLASS char * yyreds[] =
{
	"-no such reduction-",
	"statement_list : statement",
	"statement_list : identifier_list",
	"statement_list : comment",
	"statement_list : statement_list statement",
	"statement_list : '{' statement_list '}' statement",
	"statement : NAME '=' expression",
	"statement : NAME '=' expression ';'",
	"statement : NAME '=' YYSTRING",
	"statement : NAME '=' YYSTRING ';'",
	"statement : iteration_statement",
	"statement : jump_statement",
	"statement : PRINT '(' print_list ')' ';'",
	"statement : WRITE '(' YYSTRING",
	"statement : WRITE '(' YYSTRING ',' write_list ')' ';'",
	"statement : NAME PLUS_EQUALS expression",
	"statement : NAME PLUS_EQUALS expression ';'",
	"statement : NAME MINUS_EQUALS expression",
	"statement : NAME MINUS_EQUALS expression ';'",
	"statement : NAME TIMES_EQUALS expression",
	"statement : NAME TIMES_EQUALS expression ';'",
	"statement : NAME DIVIDE_EQUALS expression",
	"statement : NAME DIVIDE_EQUALS expression ';'",
	"statement : NAME INCREMENT",
	"statement : NAME INCREMENT ';'",
	"statement : NAME DECREMENT",
	"statement : NAME DECREMENT ';'",
	"statement : expression",
	"statement : expression ';'",
	"statement : '\n'",
	"statement : IF '(' expression ')'",
	"statement : ELSE",
	"comment : '#'",
	"iteration_statement : WHILE '(' statement ')' statement",
	"iteration_statement : DO statement WHILE '(' expression ')' ';'",
	"iteration_statement : FOR '(' statement statement ')' statement",
	"iteration_statement : FOR '(' statement statement expression ')' statement",
	"jump_statement : GOTO identifier ';'",
	"jump_statement : CONTINUE ';'",
	"jump_statement : BREAK ';'",
	"jump_statement : RETURN ';'",
	"jump_statement : RETURN expression ';'",
	"identifier_list : identifier",
	"identifier_list : identifier_list ',' identifier",
	"print_list : print_list ',' expression",
	"print_list : print_list ',' YYSTRING",
	"print_list : expression",
	"print_list : YYSTRING",
	"write_list : write_list ',' expression",
	"write_list : write_list ',' YYSTRING",
	"write_list : expression",
	"write_list : YYSTRING",
	"identifier : IDENTIFIER",
	"expression : expression '+' expression",
	"expression : expression '-' expression",
	"expression : expression '*' expression",
	"expression : expression '/' expression",
	"expression : '-' expression",
	"expression : '!' expression",
	"expression : '~' expression",
	"expression : '(' expression ')'",
	"expression : expression '<' expression",
	"expression : expression '>' expression",
	"expression : expression LE expression",
	"expression : expression GE expression",
	"expression : expression EQ expression",
	"expression : expression LOGICAL_AND expression",
	"expression : expression LOGICAL_OR expression",
	"expression : expression '&' expression",
	"expression : expression '|' expression",
	"expression : expression '^' expression",
	"expression : NUMBER",
	"expression : NAME",
	"expression : NAME '(' expression ')'",
	"expression : NAME '(' expression ',' expression ')'",
	"expression : NAME '(' expression ',' expression ',' expression ')'",
	"expression : NAME '(' YYSTRING ')'",
	"expression : DENSITY '[' expression ']' '[' expression ']' '[' expression ']' '[' expression ']'",
	"expression : IMAGE '[' expression ']' '[' expression ']' '[' expression ']' '[' expression ']'",
	"expression : RED '[' expression ']' '[' expression ']' '[' expression ']' '[' expression ']'",
	"expression : GREEN '[' expression ']' '[' expression ']' '[' expression ']' '[' expression ']'",
	"expression : BLUE '[' expression ']' '[' expression ']' '[' expression ']' '[' expression ']'",
	"expression : YYREAL '[' expression ']' '[' expression ']' '[' expression ']'",
	"expression : YYIMAG '[' expression ']' '[' expression ']' '[' expression ']'",
	"expression : YYWAVE '[' expression ']' '[' expression ']' '[' expression ']'",
};
#endif /* YYDEBUG */
#define YYFLAG  (-3000)
/* @(#) $Revision: 70.7 $ */    

/*
** Skeleton parser driver for yacc output
*/

#if defined(NLS) && !defined(NL_SETN)
#include <msgbuf.h>
#endif

#ifndef nl_msg
#define nl_msg(i,s) (s)
#endif

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab

#ifndef __RUNTIME_YYMAXDEPTH
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#else
#define YYACCEPT	{free_stacks(); return(0);}
#define YYABORT		{free_stacks(); return(1);}
#endif

#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( (nl_msg(30001,"syntax error - cannot backup")) );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/

#ifdef YYREENTRANT
__thread int yydebug;		/* set to 1 to get debugging */
#else
int yydebug;			/* set to 1 to get debugging */
#endif

/*
** driver internal defines
*/
/* define for YYFLAG now generated by yacc program. */
/*#define YYFLAG		(FLAGVAL)*/

/*
** global variables used by the parser
*/
# ifndef __RUNTIME_YYMAXDEPTH

#   ifdef YYREENTRANT
__thread __YYSCLASS YYSTYPE yyv[ YYMAXDEPTH ];  /* value stack */
__thread __YYSCLASS int yys[ YYMAXDEPTH ];      /* state stack */
#   else
__YYSCLASS YYSTYPE yyv[ YYMAXDEPTH ];           /* value stack */
__YYSCLASS int yys[ YYMAXDEPTH ];               /* state stack */
#   endif

# else

#  ifdef YYREENTRANT
__thread __YYSCLASS YYSTYPE *yyv;               /* pointer to malloc'ed stack st
value stack */
__thread __YYSCLASS int *yys;                   /* pointer to malloc'ed stack st
ack */
#  else
__YYSCLASS YYSTYPE *yyv;                        /* pointer to malloc'ed value st
ack */
__YYSCLASS int *yys;                            /* pointer to malloc'ed stack stack */
#  endif

#if defined(__STDC__) || defined (__cplusplus)
#include <stdlib.h>
#else
	extern char *malloc();
	extern char *realloc();
	extern void free();
#endif /* __STDC__ or __cplusplus */


static int allocate_stacks(); 
static void free_stacks();
# ifndef YYINCREMENT
# define YYINCREMENT (YYMAXDEPTH/2) + 10
# endif
# endif	/* __RUNTIME_YYMAXDEPTH */
long  yymaxdepth = YYMAXDEPTH;


#ifdef YYREENTRANT

__thread __YYSCLASS YYSTYPE *yypv;      /* top of value stack */
__thread __YYSCLASS int *yyps;          /* top of state stack */

__thread __YYSCLASS int yystate;        /* current state */
__thread __YYSCLASS int yytmp;          /* extra var (lasts between blocks) */

__thread int yynerrs;                   /* number of errors */
__thread __YYSCLASS int yyerrflag;      /* error recovery flag */
__thread int yychar;                    /* current input token number */

__thread extern int yyinit_key;           /* init TLS data once */
extern int TLS_INIT; 

#else

__YYSCLASS YYSTYPE *yypv;               /* top of value stack */
__YYSCLASS int *yyps;                   /* top of state stack */

__YYSCLASS int yystate;                 /* current state */
__YYSCLASS int yytmp;                   /* extra var (lasts between blocks) */

int yynerrs;                            /* number of errors */
__YYSCLASS int yyerrflag;               /* error recovery flag */
int yychar;
#endif


/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
l*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */


        /*
        ** Initialize externals - yyparse may be called more than once
        */

#ifdef YYREENTRANT
        if (yyinit_key != TLS_INIT)
        {
            yyinit_key = TLS_INIT; 
            yyinit_tls();
        }
#endif

	/*
	** Initialize externals - yyparse may be called more than once
	*/
# ifdef __RUNTIME_YYMAXDEPTH
	if (allocate_stacks()) YYABORT;
# endif
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
# ifndef __RUNTIME_YYMAXDEPTH
			yyerror( (nl_msg(30002,"yacc stack overflow")) );
			YYABORT;
# else
			/* save old stack bases to recalculate pointers */
			YYSTYPE * yyv_old = yyv;
			int * yys_old = yys;
			yymaxdepth += YYINCREMENT;
			yys = (int *) realloc(yys, yymaxdepth * sizeof(int));
			yyv = (YYSTYPE *) realloc(yyv, yymaxdepth * sizeof(YYSTYPE));
			if (yys==0 || yyv==0) {
			    yyerror( (nl_msg(30002,"yacc stack overflow")) );
			    YYABORT;
			    }
			/* Reset pointers into stack */
			yy_ps = (yy_ps - yys_old) + yys;
			yyps = (yyps - yys_old) + yys;
			yy_pv = (yy_pv - yyv_old) + yyv;
			yypv = (yypv - yyv_old) + yyv;
# endif

		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( (nl_msg(30003,"syntax error")) );
				yynerrs++;
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 6:
# line 189 "calculator.y"
{    yypvt[-2].symp->value = yypvt[-0].dval; 
                     read_variable("temp", tempstring, yypvt[-2].symp->datatype); 
                     if(yypvt[-2].symp->datatype == STRING)
                          add_string_variable(yypvt[-2].symp->name, tempstring, 0);
                } break;
case 8:
# line 195 "calculator.y"
{    add_string_variable(yypvt[-2].symp->name, string(yypvt[-0].symp), 0); 
                } break;
case 13:
# line 201 "calculator.y"
{    strncpy(filename, string(yypvt[-0].symp), 128);  
                     fff = (int)read_variable(filename, NULL, datatype); 
                     fp = (FILE*)fff;
                } break;
case 15:
# line 205 "calculator.y"
{ yypvt[-2].symp->value += yypvt[-0].dval; } break;
case 17:
# line 206 "calculator.y"
{ yypvt[-2].symp->value -= yypvt[-0].dval; } break;
case 19:
# line 207 "calculator.y"
{ yypvt[-2].symp->value *= yypvt[-0].dval; } break;
case 21:
# line 209 "calculator.y"
{ if (yypvt[-0].dval == 0.0)
                              yyerror("Division by zero");
                          else
                              yypvt[-2].symp->value /= yypvt[-0].dval;
                        } break;
case 23:
# line 214 "calculator.y"
{ yypvt[-1].symp->value++; } break;
case 25:
# line 215 "calculator.y"
{ yypvt[-1].symp->value--; } break;
case 27:
# line 216 "calculator.y"
{ add_variable("temp", yypvt[-0].dval); } break;
case 30:
# line 219 "calculator.y"
{
                   if( yypvt[-1].dval == 1)  if_true=1;                               
                   else        {  if_true=0;
                                  skip_to_end();
                               }
                } break;
case 31:
# line 226 "calculator.y"
{  
                   if(if_true) skip_to_end(); 
                } break;
case 32:
# line 232 "calculator.y"
{ skip_to_end_of_line(); } break;
case 44:
# line 258 "calculator.y"
{ print_number(stdout, yypvt[-0].dval); } break;
case 45:
# line 259 "calculator.y"
{ print_string(stdout, string(yypvt[-0].symp)); } break;
case 46:
# line 260 "calculator.y"
{ print_number(stdout, yypvt[-0].dval); } break;
case 47:
# line 261 "calculator.y"
{ print_string(stdout, string(yypvt[-0].symp)); } break;
case 48:
# line 265 "calculator.y"
{ print_number(fp, yypvt[-0].dval); } break;
case 49:
# line 266 "calculator.y"
{ print_string(fp, string(yypvt[-0].symp)); } break;
case 50:
# line 267 "calculator.y"
{ print_number(fp, yypvt[-0].dval);  } break;
case 51:
# line 268 "calculator.y"
{  print_string(fp, string(yypvt[-0].symp)); } break;
case 53:
# line 276 "calculator.y"
{ yyval.dval = yypvt[-2].dval + yypvt[-0].dval; } break;
case 54:
# line 277 "calculator.y"
{ yyval.dval = yypvt[-2].dval - yypvt[-0].dval; } break;
case 55:
# line 278 "calculator.y"
{ yyval.dval = yypvt[-2].dval * yypvt[-0].dval; } break;
case 56:
# line 280 "calculator.y"
{ if (yypvt[-0].dval == 0.0)
                              yyerror("Division by zero");
                          else
                              yyval.dval = yypvt[-2].dval / yypvt[-0].dval; 
                        } break;
case 57:
# line 285 "calculator.y"
{ yyval.dval = -yypvt[-0].dval; } break;
case 58:
# line 286 "calculator.y"
{ yyval.dval = !yypvt[-0].dval; } break;
case 59:
# line 287 "calculator.y"
{ yyval.dval = (double)(~(int)yypvt[-0].dval); } break;
case 60:
# line 288 "calculator.y"
{ yyval.dval = yypvt[-1].dval; } break;
case 61:
# line 289 "calculator.y"
{ yyval.dval = yypvt[-2].dval < yypvt[-0].dval; } break;
case 62:
# line 290 "calculator.y"
{ yyval.dval = yypvt[-2].dval > yypvt[-0].dval; } break;
case 63:
# line 291 "calculator.y"
{ yyval.dval = yypvt[-2].dval <= yypvt[-0].dval; } break;
case 64:
# line 292 "calculator.y"
{ yyval.dval = yypvt[-2].dval >= yypvt[-0].dval; } break;
case 65:
# line 293 "calculator.y"
{ yyval.dval = yypvt[-2].dval == yypvt[-0].dval; } break;
case 66:
# line 294 "calculator.y"
{ yyval.dval = yypvt[-2].dval && yypvt[-0].dval; } break;
case 67:
# line 295 "calculator.y"
{ yyval.dval = yypvt[-2].dval || yypvt[-0].dval; } break;
case 68:
# line 296 "calculator.y"
{ yyval.dval = (double)((int)yypvt[-2].dval & (int)yypvt[-0].dval); } break;
case 69:
# line 297 "calculator.y"
{ yyval.dval = (double)((int)yypvt[-2].dval | (int)yypvt[-0].dval); } break;
case 70:
# line 298 "calculator.y"
{ yyval.dval = (double)((int)yypvt[-2].dval ^ (int)yypvt[-0].dval); } break;
case 72:
# line 300 "calculator.y"
{  yyval.dval = yypvt[-0].symp->value; } break;
case 73:
# line 302 "calculator.y"
{  
                    if(yypvt[-3].symp->funcptr1)          /* func using a regular variable */
                        yyval.dval = (yypvt[-3].symp->funcptr1)(yypvt[-1].dval);
                    else
                    {   sprintf(tempstring, "%s is not a 1-argument function\n", yypvt[-3].symp->name);
                        yyerror(tempstring);
                        yyval.dval = 0.0;
                    }
                 } break;
case 74:
# line 312 "calculator.y"
{  
                    if(yypvt[-5].symp->funcptr2)
                        yyval.dval = (yypvt[-5].symp->funcptr2)(yypvt[-3].dval,yypvt[-1].dval);
                    else
                    {   sprintf(tempstring, "%s is not a 2-argument function\n", yypvt[-5].symp->name);
                        yyerror(tempstring);
                        yyval.dval = 0.0;
                    }
                 } break;
case 75:
# line 322 "calculator.y"
{  
                    if(yypvt[-7].symp->funcptr3)
                        yyval.dval = (yypvt[-7].symp->funcptr3)(yypvt[-5].dval,yypvt[-3].dval,yypvt[-1].dval);
                    else
                    {   sprintf(tempstring, "%s is not a 3-argument function\n", yypvt[-7].symp->name);
                        yyerror(tempstring);
                        yyval.dval = 0.0;
                    }
                 } break;
case 76:
# line 332 "calculator.y"
{  
                    if(yypvt[-3].symp->funcptrchar)
                    {   yyval.dval = (yypvt[-3].symp->funcptrchar)(string(yypvt[-1].symp));
                        status = GOTNEW;       /* Break out of pixel loop */
                    }else if(yypvt[-3].symp->funcptrchar2) /* func using a string variable  */
                    {   (yypvt[-3].symp->funcptrchar2) (string(yypvt[-1].symp), tempstring); 
                        add_string_variable("temp", tempstring, 0);
                        yypvt[-3].symp->datatype = STRING;
                        status = GOTNEW;       /* Break out of pixel loop */
                    }else
                    {   sprintf(tempstring, "%s: error executing function\n", yypvt[-3].symp->name);
                        yyerror(tempstring);
                        yyval.dval = 0.0;
                    }
                 } break;
case 77:
# line 348 "calculator.y"
{    ino    = (int) yypvt[-10].dval;
                     frame  = (int) yypvt[-7].dval;
                     x      = (int) yypvt[-4].dval;
                     y      = (int) yypvt[-1].dval;
                     comp   = (int)read_variable("COMPENSATE", NULL, datatype);
                     invert = (int)read_variable("INVERT", NULL, datatype);
                     if(between(ino, 0, g.image_count) &&
                        between(frame, 0, z[ino].frames-1) &&
                        between(x, 0, z[ino].xsize-1) &&
                        between(y, 0, z[ino].ysize-1))
                     { 
                        yyval.dval = pixeldensity_image(x, y, ino, frame, comp, invert); 
                     }else yyerror("Array out of bounds");
                } break;
case 78:
# line 363 "calculator.y"
{    ino   = (int) yypvt[-10].dval;
                     frame = (int) yypvt[-7].dval;
                     x     = (int) yypvt[-4].dval;
                     y     = (int) yypvt[-1].dval;
                     if(between(ino, 0, g.image_count) &&
                        between(frame, 0, z[ino].frames-1) &&
                        between(x, 0, z[ino].xsize-1) &&
                        between(y, 0, z[ino].ysize-1))
                     {  bpp   = z[ino].bpp;
                        yyval.dval = (double)(pixelat(z[ino].image[frame][y] + x*g.off[bpp], bpp)); 
                     }else yyerror("Array out of bounds");
                } break;
case 79:
# line 376 "calculator.y"
{    ino   = (int) yypvt[-10].dval;
                     frame = (int) yypvt[-7].dval;
                     x     = (int) yypvt[-4].dval;
                     y     = (int) yypvt[-1].dval;
                     if(between(ino, 0, g.image_count) &&
                        between(frame, 0, z[ino].frames-1) &&
                        between(x, 0, z[ino].xsize-1) &&
                        between(y, 0, z[ino].ysize-1))
                     {  bpp   = z[ino].bpp;
                        v = pixelat(z[ino].image[frame][y] + x*g.off[bpp], bpp); 
                        valuetoRGB(v,rr,gg,bb,bpp);
                        yyval.dval = (double)rr;
                     }else yyerror("Array out of bounds");
                } break;
case 80:
# line 391 "calculator.y"
{    ino   = (int) yypvt[-10].dval;
                     frame = (int) yypvt[-7].dval;
                     x     = (int) yypvt[-4].dval;
                     y     = (int) yypvt[-1].dval;
                     if(between(ino, 0, g.image_count) &&
                        between(frame, 0, z[ino].frames-1) &&
                        between(x, 0, z[ino].xsize-1) &&
                        between(y, 0, z[ino].ysize-1))
                     {  bpp   = z[ino].bpp;
                        v = pixelat(z[ino].image[frame][y] + x*g.off[bpp], bpp); 
                        valuetoRGB(v,rr,gg,bb,bpp);
                        yyval.dval = (double)gg;
                     }else yyerror("Array out of bounds");
                } break;
case 81:
# line 406 "calculator.y"
{    ino   = (int) yypvt[-10].dval;
                     frame = (int) yypvt[-7].dval;
                     x     = (int) yypvt[-4].dval;
                     y     = (int) yypvt[-1].dval;
                     if(between(ino, 0, g.image_count) &&
                        between(frame, 0, z[ino].frames-1) &&
                        between(x, 0, z[ino].xsize-1) &&
                        between(y, 0, z[ino].ysize-1))
                     {  bpp   = z[ino].bpp;
                        v = pixelat(z[ino].image[frame][y] + x*g.off[bpp], bpp); 
                        valuetoRGB(v,rr,gg,bb,bpp);
                        yyval.dval = (double)bb;
                     }else yyerror("Array out of bounds");
                } break;
case 82:
# line 421 "calculator.y"
{    ino   = (int) yypvt[-7].dval;
                     x     = (int) yypvt[-4].dval;
                     y     = (int) yypvt[-1].dval;
                     if(between(ino, 0, g.image_count-1) &&
                        between(x, 0, z[ino].xsize-1) &&
                        between(y, 0, z[ino].ysize-1) &&
                        z[ino].floatexists)
                          yyval.dval = z[ino].fft[y][x].real();
                     else yyerror("Array out of bounds");
                } break;
case 83:
# line 432 "calculator.y"
{    ino   = (int) yypvt[-7].dval;
                     x     = (int) yypvt[-4].dval;
                     y     = (int) yypvt[-1].dval;
                     if(between(ino, 0, g.image_count-1) &&
                        between(x, 0, z[ino].xsize-1) &&
                        between(y, 0, z[ino].ysize-1) &&
                        z[ino].floatexists)
                          yyval.dval = z[ino].fft[y][x].imag();
                     else yyerror("Array out of bounds");
                } break;
case 84:
# line 443 "calculator.y"
{    ino   = (int) yypvt[-7].dval;
                     x     = (int) yypvt[-4].dval;
                     y     = (int) yypvt[-1].dval;
                     if(between(ino, 0, g.image_count-1) &&
                        between(x, 0, z[ino].xsize-1) &&
                        between(y, 0, z[ino].ysize-1) &&
                        z[ino].waveletexists)
                          yyval.dval = z[ino].wavelet[y][x];
                     else yyerror("Array out of bounds");
                } break;
	}
	goto yystack;		/* reset registers in driver code */
}

# ifdef __RUNTIME_YYMAXDEPTH

static int allocate_stacks() {
	/* allocate the yys and yyv stacks */
	yys = (int *) malloc(yymaxdepth * sizeof(int));
	yyv = (YYSTYPE *) malloc(yymaxdepth * sizeof(YYSTYPE));

	if (yys==0 || yyv==0) {
	   yyerror( (nl_msg(30004,"unable to allocate space for yacc stacks")) );
	   return(1);
	   }
	else return(0);

}


static void free_stacks() {
	if (yys!=0) free((char *) yys);
	if (yyv!=0) free((char *) yyv);
}

# endif  /* defined(__RUNTIME_YYMAXDEPTH) */

